<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'FreeTrialCTA',
  props: {
    variant: {
      type: String,
      required: false,
      default: 'standard',
    },
    title: {
      type: String,
      required: false,
      default: '',
    },
    subtitle: {
      type: String,
      required: false,
      default: '',
    },
    primaryButtonType: {
      type: String,
      required: false,
      default: 'contact_sales',
    },
    secondaryButtonType: {
      type: String,
      required: false,
      default: 'free_trial',
    },
    data: {
      type: Object,
      required: false,
      default: null,
    },
  },
  data() {
    return {
      content: [],
    };
  },
  async fetch() {
    const content = (await this.$content(
      'shared/en-us/free-trial-cta',
    ).fetch()) as any;
    this.content = content;
  },
});
</script>

<template>
  <div v-if="variant === 'image'" class="slp-free-trial-cta">
    <nuxt-img
      class="slp-my-16 slp-free-trial-cta__image"
      :src="content.image_variant.image"
      alt=""
      loading="lazy"
      format="webp"
      quality="99"
    />
    <SlpTypography tag="h3" variant="heading4" class="slp-my-16">{{
      title || content.title
    }}</SlpTypography>
    <SlpTypography tag="p" variant="body1" class="slp-mb-16 subtitle">{{
      subtitle || content.subtitle
    }}</SlpTypography>
    <div class="slp-free-trial-cta__buttons">
      <SlpButton
        :href="content.image_variant[`${primaryButtonType}_button`].link"
        :data-ga-name="
          content.image_variant[`${primaryButtonType}_button`].data_ga_name
        "
        :data-ga-location="
          content.image_variant[`${primaryButtonType}_button`].data_ga_location
        "
        >{{ content.image_variant[`${primaryButtonType}_button`].text }}
      </SlpButton>
      <SlpButton
        variant="secondary"
        :href="content.image_variant[`${secondaryButtonType}_button`].link"
        :data-ga-name="
          content.image_variant[`${secondaryButtonType}_button`].data_ga_name
        "
        :data-ga-location="
          content.image_variant[`${secondaryButtonType}_button`]
            .data_ga_location
        "
      >
        {{ content.image_variant[`${secondaryButtonType}_button`].text }}
      </SlpButton>
    </div>
  </div>
  <section v-else-if="variant === 'no-image-cta'">
    <div class="slp-free-trial-no-image-cta">
      <div class="header">
        <SlpTypography tag="h2" variant="heading3-bold" class="slp-mb-8">
          {{ data.header }}
        </SlpTypography>
        <SlpTypography tag="p" variant="heading5" class="slp-mb-24">
          {{ data.subtitle }}
        </SlpTypography>
        <SlpButton
          variant="primary"
          :href="data.header_cta.href"
          :data-ga-name="data.header_cta.data_ga_name"
          :data-ga-location="data.header_cta.data_ga_location"
        >
          {{ data.header_cta.text }}
        </SlpButton>
      </div>
      <div class="cards">
        <div class="card">
          <SlpIcon
            variant="marketing"
            :name="data.card1.icon"
            size="md"
            alt=""
            class="slp-mb-24"
          />
          <SlpTypography variant="heading5" tag="h3" class="slp-mb-16">
            {{ data.card1.header }}
          </SlpTypography>
          <SlpButton
            variant="tertiary"
            :href="data.card1.cta_link"
            :data-ga-name="data.card1.data_ga_name"
            :data-ga-location="data.card1.data_ga_location"
          >
            {{ data.card1.cta_text }}
            <SlpIcon name="chevron-lg-right" variant="product" size="sm" />
          </SlpButton>
        </div>
        <div class="card">
          <SlpIcon
            variant="marketing"
            :name="data.card2.icon"
            size="md"
            alt=""
            class="slp-mb-24"
          />
          <SlpTypography variant="heading5" tag="h3" class="slp-mb-16">
            {{ data.card2.header }}
          </SlpTypography>
          <SlpButton
            variant="tertiary"
            :href="data.card2.link"
            :data-ga-name="data.card2.data_ga_name"
            :data-ga-location="data.card2.data_ga_location"
          >
            {{ data.card2.cta_text }}
            <SlpIcon name="chevron-lg-right" variant="product" size="sm" />
          </SlpButton>
        </div>
      </div>
    </div>
  </section>
  <div v-else>
    <div class="slp-free-trial-cta">
      <nuxt-img
        class="slp-mb-16"
        :src="content.confetti"
        alt=""
        loading="lazy"
        format="webp"
        quality="99"
      />
      <SlpTypography tag="h3" variant="heading4" class="slp-my-16">{{
        content.title
      }}</SlpTypography>
      <SlpTypography tag="p" variant="body1" class="slp-mb-16 subtitle">{{
        content.subtitle
      }}</SlpTypography>
      <div class="slp-free-trial-cta__buttons">
        <SlpButton
          variant="charcoal"
          :data-ga-name="content[`${primaryButtonType}_button`].data_ga_name"
          :data-ga-location="
            content[`${primaryButtonType}_button`].data_ga_location
          "
          :href="content[`${primaryButtonType}_button`].link"
          >{{ content[`${primaryButtonType}_button`].text }}
        </SlpButton>
        <SlpButton
          variant="secondary"
          :href="content[`${secondaryButtonType}_button`].link"
          :data-ga-name="content[`${secondaryButtonType}_button`].data_ga_name"
          :data-ga-location="
            content[`${secondaryButtonType}_button`].data_ga_location
          "
        >
          {{ content[`${secondaryButtonType}_button`].text }}
        </SlpButton>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.slp-free-trial-no-image-cta {
  margin-bottom: 128px;
  display: flex;
  flex-direction: row;
  flex-wrap: nowrap;
  justify-content: space-between;
  align-items: center;
  gap: 0 24px;

  .header {
    flex: 0 0 40%;
  }

  .cards {
    display: flex;
    flex-direction: row;
    flex-wrap: nowrap;
    justify-content: space-between;
    align-items: center;
    gap: 0 $spacing-96;
  }

  .card {
    max-width: 233px;
  }

  @media (max-width: $breakpoint-md) {
    flex-wrap: wrap;
    margin: $spacing-64 0;

    .header {
      flex: 1 0 100%;
      margin-bottom: $spacing-48;
    }

    .cards {
      flex-wrap: wrap;
    }

    .card {
      max-width: 100%;
      margin-bottom: $spacing-24;
    }
  }
}
.slp-free-trial-cta {
  display: flex;
  align-items: center;
  flex-direction: column;
  margin-bottom: 128px;
  text-align: center;

  &__image {
    width: 213px;
  }

  .subtitle {
    text-align: center;
    @media (min-width: $breakpoint-md) {
      width: 60%;
    }
  }

  &__buttons {
    display: flex;
    flex-direction: column;
    width: 100%;

    @media (min-width: $breakpoint-md) {
      flex-direction: row;
      align-items: center;
      justify-content: center;
      width: unset;
    }

    a {
      width: 100%;
      margin-bottom: $spacing-8;

      @media (min-width: $breakpoint-md) {
        width: unset;
        margin-bottom: inherit;
        margin-right: $spacing-4;
        margin-left: $spacing-4;
      }
    }
  }
}
</style>
